# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::StorSimple8000Series::Mgmt::V2017_06_01
  module Models
    #
    # Represents available provider operation.
    #
    class AvailableProviderOperation

      include MsRestAzure

      # @return [String] The name of the operation being performed on a
      # particular object. Name format:
      # "{resourceProviderNamespace}/{resourceType}/{read|write|delete|action}".
      # Eg. Microsoft.StorSimple/managers/devices/volumeContainers/read,
      # Microsoft.StorSimple/managers/devices/alerts/clearAlerts/action
      attr_accessor :name

      # @return [AvailableProviderOperationDisplay] Contains the localized
      # display information for this particular operation/action.
      attr_accessor :display

      # @return [String] The intended executor of the operation; governs the
      # display of the operation in the RBAC UX and the audit logs UX. Default
      # value is "user,system"
      attr_accessor :origin

      # @return Reserved for future use.
      attr_accessor :properties


      #
      # Mapper for AvailableProviderOperation class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'AvailableProviderOperation',
          type: {
            name: 'Composite',
            class_name: 'AvailableProviderOperation',
            model_properties: {
              name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              display: {
                client_side_validation: true,
                required: false,
                serialized_name: 'display',
                type: {
                  name: 'Composite',
                  class_name: 'AvailableProviderOperationDisplay'
                }
              },
              origin: {
                client_side_validation: true,
                required: false,
                serialized_name: 'origin',
                type: {
                  name: 'String'
                }
              },
              properties: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties',
                type: {
                  name: 'Object'
                }
              }
            }
          }
        }
      end
    end
  end
end
