# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::StorSimple8000Series::Mgmt::V2017_06_01
  module Models
    #
    # The backup schedule.
    #
    class BackupSchedule < BaseModel

      include MsRestAzure

      # @return [ScheduleRecurrence] The schedule recurrence.
      attr_accessor :schedule_recurrence

      # @return [BackupType] The type of backup which needs to be taken.
      # Possible values include: 'LocalSnapshot', 'CloudSnapshot'
      attr_accessor :backup_type

      # @return [Integer] The number of backups to be retained.
      attr_accessor :retention_count

      # @return [DateTime] The start time of the schedule.
      attr_accessor :start_time

      # @return [ScheduleStatus] The schedule status. Possible values include:
      # 'Enabled', 'Disabled'
      attr_accessor :schedule_status

      # @return [DateTime] The last successful backup run which was triggered
      # for the schedule.
      attr_accessor :last_successful_run


      #
      # Mapper for BackupSchedule class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'BackupSchedule',
          type: {
            name: 'Composite',
            class_name: 'BackupSchedule',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              kind: {
                client_side_validation: true,
                required: false,
                serialized_name: 'kind',
                type: {
                  name: 'Enum',
                  module: 'Kind'
                }
              },
              schedule_recurrence: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.scheduleRecurrence',
                type: {
                  name: 'Composite',
                  class_name: 'ScheduleRecurrence'
                }
              },
              backup_type: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.backupType',
                type: {
                  name: 'Enum',
                  module: 'BackupType'
                }
              },
              retention_count: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.retentionCount',
                type: {
                  name: 'Number'
                }
              },
              start_time: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.startTime',
                type: {
                  name: 'DateTime'
                }
              },
              schedule_status: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.scheduleStatus',
                type: {
                  name: 'Enum',
                  module: 'ScheduleStatus'
                }
              },
              last_successful_run: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.lastSuccessfulRun',
                type: {
                  name: 'DateTime'
                }
              }
            }
          }
        }
      end
    end
  end
end
