# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::StorSimple8000Series::Mgmt::V2017_06_01
  module Models
    #
    # The cloud appliance configuration
    #
    class CloudApplianceConfiguration < BaseModel

      include MsRestAzure

      # @return [String] The model number.
      attr_accessor :model_number

      # @return [String] The cloud platform.
      attr_accessor :cloud_platform

      # @return [AcsConfiguration] The ACS configuration.
      attr_accessor :acs_configuration

      # @return [Array<String>] The supported storage account types.
      attr_accessor :supported_storage_account_types

      # @return [Array<String>] The supported regions.
      attr_accessor :supported_regions

      # @return [Array<String>] The supported virtual machine types.
      attr_accessor :supported_vm_types

      # @return [Array<VmImage>] The supported virtual machine images.
      attr_accessor :supported_vm_images


      #
      # Mapper for CloudApplianceConfiguration class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'CloudApplianceConfiguration',
          type: {
            name: 'Composite',
            class_name: 'CloudApplianceConfiguration',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              kind: {
                client_side_validation: true,
                required: false,
                serialized_name: 'kind',
                type: {
                  name: 'Enum',
                  module: 'Kind'
                }
              },
              model_number: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.modelNumber',
                type: {
                  name: 'String'
                }
              },
              cloud_platform: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.cloudPlatform',
                type: {
                  name: 'String'
                }
              },
              acs_configuration: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.acsConfiguration',
                type: {
                  name: 'Composite',
                  class_name: 'AcsConfiguration'
                }
              },
              supported_storage_account_types: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.supportedStorageAccountTypes',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              supported_regions: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.supportedRegions',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              supported_vm_types: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.supportedVmTypes',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              supported_vm_images: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.supportedVmImages',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'VmImageElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'VmImage'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
