# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::StorSimple8000Series::Mgmt::V2017_06_01
  module Models
    #
    # The mandatory device configuration request.
    #
    class ConfigureDeviceRequest < BaseModel

      include MsRestAzure

      # @return [String] The friendly name for the device.
      attr_accessor :friendly_name

      # @return [String] The current name of the device.
      attr_accessor :current_device_name

      # @return [String] The device time zone. For eg: "Pacific Standard Time"
      attr_accessor :time_zone

      # @return [SecondaryDNSSettings] The secondary DNS Settings of the
      # device.
      attr_accessor :dns_settings

      # @return [NetworkInterfaceData0Settings] The 'Data 0' network interface
      # card settings.
      attr_accessor :network_interface_data0settings


      #
      # Mapper for ConfigureDeviceRequest class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ConfigureDeviceRequest',
          type: {
            name: 'Composite',
            class_name: 'ConfigureDeviceRequest',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              kind: {
                client_side_validation: true,
                required: false,
                serialized_name: 'kind',
                type: {
                  name: 'Enum',
                  module: 'Kind'
                }
              },
              friendly_name: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.friendlyName',
                type: {
                  name: 'String'
                }
              },
              current_device_name: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.currentDeviceName',
                type: {
                  name: 'String'
                }
              },
              time_zone: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.timeZone',
                type: {
                  name: 'String'
                }
              },
              dns_settings: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.dnsSettings',
                type: {
                  name: 'Composite',
                  class_name: 'SecondaryDNSSettings'
                }
              },
              network_interface_data0settings: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.networkInterfaceData0Settings',
                type: {
                  name: 'Composite',
                  class_name: 'NetworkInterfaceData0Settings'
                }
              }
            }
          }
        }
      end
    end
  end
end
