# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::StorSimple8000Series::Mgmt::V2017_06_01
  module Models
    #
    # The extended info of the manager.
    #
    class ManagerExtendedInfo < BaseModel

      include MsRestAzure

      # @return [String] The version of the extended info being persisted.
      attr_accessor :version

      # @return [String] Represents the CIK of the resource.
      attr_accessor :integrity_key

      # @return [String] Represents the CEK of the resource.
      attr_accessor :encryption_key

      # @return [String] Represents the Cert thumbprint that was used to
      # encrypt the CEK.
      attr_accessor :encryption_key_thumbprint

      # @return [String] Represents the portal thumbprint which can be used
      # optionally to encrypt the entire data before storing it.
      attr_accessor :portal_certificate_thumbprint

      # @return [String] Represents the encryption algorithm used to encrypt
      # the keys. None - if Key is saved in plain text format. Algorithm name -
      # if key is encrypted
      attr_accessor :algorithm

      # @return [String] The etag of the resource.
      attr_accessor :etag


      #
      # Mapper for ManagerExtendedInfo class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ManagerExtendedInfo',
          type: {
            name: 'Composite',
            class_name: 'ManagerExtendedInfo',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              kind: {
                client_side_validation: true,
                required: false,
                serialized_name: 'kind',
                type: {
                  name: 'Enum',
                  module: 'Kind'
                }
              },
              version: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.version',
                type: {
                  name: 'String'
                }
              },
              integrity_key: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.integrityKey',
                type: {
                  name: 'String'
                }
              },
              encryption_key: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.encryptionKey',
                type: {
                  name: 'String'
                }
              },
              encryption_key_thumbprint: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.encryptionKeyThumbprint',
                type: {
                  name: 'String'
                }
              },
              portal_certificate_thumbprint: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.portalCertificateThumbprint',
                type: {
                  name: 'String'
                }
              },
              algorithm: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.algorithm',
                type: {
                  name: 'String'
                }
              },
              etag: {
                client_side_validation: true,
                required: false,
                serialized_name: 'etag',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
