# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::StorSimple8000Series::Mgmt::V2017_06_01
  module Models
    #
    # Represents the patch request for the security settings of a device.
    #
    class SecuritySettingsPatch

      include MsRestAzure

      # @return [RemoteManagementSettingsPatch] The remote management settings.
      attr_accessor :remote_management_settings

      # @return [AsymmetricEncryptedSecret] The device administrator password.
      attr_accessor :device_admin_password

      # @return [AsymmetricEncryptedSecret] The snapshot manager password.
      attr_accessor :snapshot_password

      # @return [ChapSettings] The device CHAP and reverse-CHAP settings.
      attr_accessor :chap_settings

      # @return [CloudApplianceSettings] The cloud appliance settings.
      attr_accessor :cloud_appliance_settings


      #
      # Mapper for SecuritySettingsPatch class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'SecuritySettingsPatch',
          type: {
            name: 'Composite',
            class_name: 'SecuritySettingsPatch',
            model_properties: {
              remote_management_settings: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.remoteManagementSettings',
                type: {
                  name: 'Composite',
                  class_name: 'RemoteManagementSettingsPatch'
                }
              },
              device_admin_password: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.deviceAdminPassword',
                type: {
                  name: 'Composite',
                  class_name: 'AsymmetricEncryptedSecret'
                }
              },
              snapshot_password: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.snapshotPassword',
                type: {
                  name: 'Composite',
                  class_name: 'AsymmetricEncryptedSecret'
                }
              },
              chap_settings: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.chapSettings',
                type: {
                  name: 'Composite',
                  class_name: 'ChapSettings'
                }
              },
              cloud_appliance_settings: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.cloudApplianceSettings',
                type: {
                  name: 'Composite',
                  class_name: 'CloudApplianceSettings'
                }
              }
            }
          }
        }
      end
    end
  end
end
