# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::StorSimple8000Series::Mgmt::V2017_06_01
  module Models
    #
    # Represents the secrets encrypted using Symmetric Encryption Key.
    #
    class SymmetricEncryptedSecret

      include MsRestAzure

      # @return [String] The value of the secret itself. If the secret is in
      # plaintext or null then EncryptionAlgorithm will be none.
      attr_accessor :value

      # @return [String] The thumbprint of the cert that was used to encrypt
      # "Value".
      attr_accessor :value_certificate_thumbprint

      # @return [EncryptionAlgorithm] The algorithm used to encrypt the
      # "Value". Possible values include: 'None', 'AES256', 'RSAES_PKCS1_v_1_5'
      attr_accessor :encryption_algorithm


      #
      # Mapper for SymmetricEncryptedSecret class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'SymmetricEncryptedSecret',
          type: {
            name: 'Composite',
            class_name: 'SymmetricEncryptedSecret',
            model_properties: {
              value: {
                client_side_validation: true,
                required: true,
                serialized_name: 'value',
                type: {
                  name: 'String'
                }
              },
              value_certificate_thumbprint: {
                client_side_validation: true,
                required: false,
                serialized_name: 'valueCertificateThumbprint',
                type: {
                  name: 'String'
                }
              },
              encryption_algorithm: {
                client_side_validation: true,
                required: true,
                serialized_name: 'encryptionAlgorithm',
                type: {
                  name: 'Enum',
                  module: 'EncryptionAlgorithm'
                }
              }
            }
          }
        }
      end
    end
  end
end
