# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::StorSimple8000Series::Mgmt::V2017_06_01
  module Models
    #
    # The time settings of a device.
    #
    class TimeSettings < BaseModel

      include MsRestAzure

      # @return [String] The timezone of device, like '(UTC -06:00) Central
      # America'
      attr_accessor :time_zone

      # @return [String] The primary Network Time Protocol (NTP) server name,
      # like 'time.windows.com'.
      attr_accessor :primary_time_server

      # @return [Array<String>] The secondary Network Time Protocol (NTP)
      # server name, like 'time.contoso.com'. It's optional.
      attr_accessor :secondary_time_server


      #
      # Mapper for TimeSettings class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'TimeSettings',
          type: {
            name: 'Composite',
            class_name: 'TimeSettings',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              kind: {
                client_side_validation: true,
                required: false,
                serialized_name: 'kind',
                type: {
                  name: 'Enum',
                  module: 'Kind'
                }
              },
              time_zone: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.timeZone',
                type: {
                  name: 'String'
                }
              },
              primary_time_server: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.primaryTimeServer',
                type: {
                  name: 'String'
                }
              },
              secondary_time_server: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.secondaryTimeServer',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
