# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::StorSimple8000Series::Mgmt::V2017_06_01
  module Models
    #
    # The updates profile of a device.
    #
    class Updates < BaseModel

      include MsRestAzure

      # @return [Boolean] Set to 'true' if regular updates are available for
      # the device.
      attr_accessor :regular_updates_available

      # @return [Boolean] Set to 'true' if maintenance mode update available.
      attr_accessor :maintenance_mode_updates_available

      # @return [Boolean] Indicates whether an update is in progress or not.
      attr_accessor :is_update_in_progress

      # @return [DateTime] The time when the last update was completed.
      attr_accessor :last_updated_time


      #
      # Mapper for Updates class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'Updates',
          type: {
            name: 'Composite',
            class_name: 'Updates',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              kind: {
                client_side_validation: true,
                required: false,
                serialized_name: 'kind',
                type: {
                  name: 'Enum',
                  module: 'Kind'
                }
              },
              regular_updates_available: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.regularUpdatesAvailable',
                type: {
                  name: 'Boolean'
                }
              },
              maintenance_mode_updates_available: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.maintenanceModeUpdatesAvailable',
                type: {
                  name: 'Boolean'
                }
              },
              is_update_in_progress: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.isUpdateInProgress',
                type: {
                  name: 'Boolean'
                }
              },
              last_updated_time: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.lastUpdatedTime',
                type: {
                  name: 'DateTime'
                }
              }
            }
          }
        }
      end
    end
  end
end
