# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::StorSimple8000Series::Mgmt::V2017_06_01
  module Models
    #
    # The metadata of a volume that has valid cloud snapshot.
    #
    class VolumeFailoverMetadata

      include MsRestAzure

      # @return [String] The path ID of the volume.
      attr_accessor :volume_id

      # @return [VolumeType] The type of the volume. Possible values include:
      # 'Tiered', 'Archival', 'LocallyPinned'
      attr_accessor :volume_type

      # @return [Integer] The size of the volume in bytes at the time the
      # snapshot was taken.
      attr_accessor :size_in_bytes

      # @return [DateTime] The date at which the snapshot was taken.
      attr_accessor :backup_created_date

      # @return [String] The path ID of the backup-element for this volume,
      # inside the backup set.
      attr_accessor :backup_element_id

      # @return [String] The path ID of the backup set.
      attr_accessor :backup_id

      # @return [String] The path ID of the backup policy using which the
      # snapshot was taken.
      attr_accessor :backup_policy_id


      #
      # Mapper for VolumeFailoverMetadata class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'VolumeFailoverMetadata',
          type: {
            name: 'Composite',
            class_name: 'VolumeFailoverMetadata',
            model_properties: {
              volume_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'volumeId',
                type: {
                  name: 'String'
                }
              },
              volume_type: {
                client_side_validation: true,
                required: false,
                serialized_name: 'volumeType',
                type: {
                  name: 'Enum',
                  module: 'VolumeType'
                }
              },
              size_in_bytes: {
                client_side_validation: true,
                required: false,
                serialized_name: 'sizeInBytes',
                type: {
                  name: 'Number'
                }
              },
              backup_created_date: {
                client_side_validation: true,
                required: false,
                serialized_name: 'backupCreatedDate',
                type: {
                  name: 'DateTime'
                }
              },
              backup_element_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'backupElementId',
                type: {
                  name: 'String'
                }
              },
              backup_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'backupId',
                type: {
                  name: 'String'
                }
              },
              backup_policy_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'backupPolicyId',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
